"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.MessagingSidecar = void 0;
/**
 * Sidecar example agent
 *
 * Huan <zixia@zixia.net>, June 24, 2021
 *  https://github.com/huan/sidecar
 */
var events_1 = require("events");
var brolog_1 = require("brolog");
var frida = __importStar(require("./frida"));
var load_agent_source_1 = require("./load-agent-source");
var MessagingSidecar = /** @class */ (function (_super) {
    __extends(MessagingSidecar, _super);
    function MessagingSidecar() {
        var _this = _super.call(this) || this;
        brolog_1.log.verbose('MessagingSidecar', 'constructor()');
        return _this;
    }
    MessagingSidecar.prototype.init = function () {
        return __awaiter(this, void 0, void 0, function () {
            var session, agentSource, script;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        brolog_1.log.verbose('MessagingSidecar', 'init()');
                        return [4 /*yield*/, frida.attach('messaging')];
                    case 1:
                        session = _a.sent();
                        return [4 /*yield*/, (0, load_agent_source_1.loadAgentSource)()];
                    case 2:
                        agentSource = _a.sent();
                        return [4 /*yield*/, session.createScript(agentSource)];
                    case 3:
                        script = _a.sent();
                        script.message.connect(this.scriptMessageHandler.bind(this));
                        script.destroyed.connect(this.scriptDestroyedHandler.bind(this));
                        return [4 /*yield*/, script.load()];
                    case 4:
                        _a.sent();
                        this.session = session;
                        this.script = script;
                        return [2 /*return*/];
                }
            });
        });
    };
    MessagingSidecar.prototype.start = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        brolog_1.log.verbose('MessagingSidecar', 'stop()');
                        if (!this.script) {
                            throw new Error('stop() this.script is undefined!');
                        }
                        return [4 /*yield*/, this.script.exports.init()];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    MessagingSidecar.prototype.stop = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        brolog_1.log.verbose('MessagingSidecar', 'stop()');
                        if (!this.script) return [3 /*break*/, 2];
                        return [4 /*yield*/, this.script.unload()];
                    case 1:
                        _a.sent();
                        this.script = undefined;
                        return [3 /*break*/, 3];
                    case 2: throw new Error('stop() this.script is undefined!');
                    case 3:
                        if (!this.session) return [3 /*break*/, 5];
                        return [4 /*yield*/, this.session.detach()];
                    case 4:
                        _a.sent();
                        this.session = undefined;
                        return [3 /*break*/, 6];
                    case 5: throw new Error('stop() this.session is undefined!');
                    case 6: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * ScriptMessageHandler
     */
    MessagingSidecar.prototype.scriptMessageHandler = function (message, data) {
        brolog_1.log.verbose('MessagingSidecar', 'scriptMessageHandler(%s, %s)', JSON.stringify(message), data);
        switch (message.type) {
            case frida.MessageType.Send:
                brolog_1.log.silly('MessagingSidecar', 'scriptMessagerHandler() MessageType.Send: %s', JSON.stringify(message.payload));
                this.emitPayload(message.payload, data);
                break;
            case frida.MessageType.Error:
                brolog_1.log.silly('MessagingSidecar', 'scriptMessagerHandler() MessageType.Error: %s', message.stack);
                break;
            default:
                throw new Error('MessagingSidecar: scriptMessagerHandler() Error: unknown message type: ' + message);
        }
        if (data) {
            brolog_1.log.silly('MessagingSidecar', 'scriptMessageHandler() data:', data);
        }
    };
    MessagingSidecar.prototype.emitPayload = function (payload, data) {
        brolog_1.log.verbose('MessagingSidecar', 'emitPayload(%s, %s)', payload, data);
        this.emit('hook', payload);
    };
    /**
     * ScriptDestroyedHandler
     */
    MessagingSidecar.prototype.scriptDestroyedHandler = function () {
        brolog_1.log.verbose('MessagingSidecar', 'scriptDestroyedHandler()');
    };
    MessagingSidecar.prototype.mo = function (content) {
        return __awaiter(this, void 0, void 0, function () {
            var e_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        brolog_1.log.verbose('MessagingSidecar', 'mo(%s)', content);
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, this.script.exports.mo('MessagingSidebar: new messsage send by script.exports.mo()')];
                    case 2:
                        _a.sent();
                        return [3 /*break*/, 4];
                    case 3:
                        e_1 = _a.sent();
                        console.error(e_1);
                        return [3 /*break*/, 4];
                    case 4: return [2 /*return*/];
                }
            });
        });
    };
    return MessagingSidecar;
}(events_1.EventEmitter));
exports.MessagingSidecar = MessagingSidecar;
//# sourceMappingURL=messaging-sidecar.js.map