#!/usr/bin/env ts-node
"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * Huan(202106) see:
 *  http://blog.wolksoftware.com/decorators-metadata-reflection-in-typescript-from-novice-to-expert-part-4
 *
 * Another great blog post with the decorator runtime order tests:
 *  https://medium.com/jspoint/anatomy-of-typescript-decorators-and-their-usage-patterns-487729b34ae6
 */
var tstest_1 = require("tstest");
(0, tstest_1.test)('decorator execute order', function (t) { return __awaiter(void 0, void 0, void 0, function () {
    var orderList, decorateClass, decorateProperty, decorateParam, decorateMethod, Test, EXPECTED_ORDER_LIST;
    return __generator(this, function (_a) {
        orderList = [];
        decorateClass = function (target) { orderList.push('class:' + target.name); };
        decorateProperty = function (_target, propertyKey) { orderList.push('property:' + propertyKey); };
        decorateParam = function (_target, methodKey, index) { orderList.push('param:' + methodKey + '/' + index); };
        decorateMethod = function (_target, methodKey, _descriptor) { orderList.push('method:' + methodKey); };
        Test = /** @class */ (function () {
            function Test() {
            }
            Test.prototype.method1 = function (_arg) { };
            Test.prototype.method2 = function (_arg1, _arg2) { };
            __decorate([
                decorateProperty,
                __metadata("design:type", Object)
            ], Test.prototype, "_prop1", void 0);
            __decorate([
                decorateProperty,
                __metadata("design:type", Object)
            ], Test.prototype, "_prop2", void 0);
            __decorate([
                decorateMethod,
                __param(0, decorateParam),
                __metadata("design:type", Function),
                __metadata("design:paramtypes", [Object]),
                __metadata("design:returntype", void 0)
            ], Test.prototype, "method1", null);
            __decorate([
                decorateMethod,
                __param(0, decorateParam),
                __param(1, decorateParam),
                __metadata("design:type", Function),
                __metadata("design:paramtypes", [Object, Object]),
                __metadata("design:returntype", void 0)
            ], Test.prototype, "method2", null);
            Test = __decorate([
                decorateClass
            ], Test);
            return Test;
        }());
        void Test;
        EXPECTED_ORDER_LIST = [
            'property:_prop1',
            'property:_prop2',
            'param:method1/0',
            'method:method1',
            'param:method2/1',
            'param:method2/0',
            'method:method2',
            'class:Test',
        ];
        t.deepEqual(orderList, EXPECTED_ORDER_LIST, 'should get the expected execute order of decorators');
        return [2 /*return*/];
    });
}); });
//# sourceMappingURL=decorator-execute-order.spec.js.map